// FILENAME:	Ice_Land.cs
//
// AUTHORS:  	Some1
//------------------------------------------------------------------------------

$missionName = "Ice_Land";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("SoMe1stdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;
}

function onMissionEnd()
{
	deleteObject($hara1);
	deleteObject($prom1);
	deleteObject($caan1);
}

function onMissionLoad()
{
   cdAudioCycle("yougot");
}

// move the map
$server::HudMapViewOffsetX = -1500;
$server::HudMapViewOffsetY = 2500;

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
        $hara1 = getObjectId("Missiongroup\\hara1");
        $prom1 = getObjectId("Missiongroup\\prom1");
        $caan1 = getObjectId("Missiongroup\\caan1");
	setPilotId($hara1, 57);
        setPilotId($prom1, 59);
        setPilotId($caan1, 58);
	IceSounds();
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

function player::onAdd(%this)
{
  say(%this, 0, "<f2>Welcome to Ice Land.  Don't shoot the beer at Red, it wouldn't be nice, because it's a not nice thing.  If you do a worse not nice thing could happen to you.  You can join GoP at www.gopss.cjb.net on the Join Page.  Map made by [GoP]~SoMeOnE~TL.");
}
function beer::structure::onAttacked(%attacked, %attacker)
{
	messageBox(%attacker, "You shoot Beer! You very bad BAD person!  You die now!! You die real good!");
	healObject(%attacker, -50000);
	healObject(%attacked, 50000);
}
function death::structure::onAttacked(%attacked, %attacker)
{
	healObject(%attacked, 50000);
	messageBox(%attacker, "You were warned...");
	setPosition(%attacker, -8098.1, 3726.8, 342.2);
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   if(%destroyed == $hara1)
   {
      $hara1 = cloneVehicle(%destroyed);
      setTeam($hara1, getTeam(%destroyed));
      reDrop($hara1);
      order($hara1, attack, %destroyer);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $prom1)
   {
      $prom1 = cloneVehicle(%destroyed);
      setTeam($prom1, getTeam(%destroyed));
      reDrop($prom1);
      order($prom1, attack, %destroyer);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $caan1)
   {
      $caan1 = cloneVehicle(%destroyed);
      setTeam($caan1, getTeam(%destroyed));
      reDrop($caan1);
      order($caan1, guard, %destroyer);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // this is weird but %destroyer isn't necessarily a vehicle
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   
}