// FILENAME:	Particle_Accelerater.cs
//
// AUTHORS:  	SoMe1
//------------------------------------------------------------------------------

$missionName = "Particle_Accelerater";

$server::HudMapViewOffsetX = 500; 
$server::HudMapViewOffsetY = 4000; 

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
	mercurySounds();
}

function onMissionLoad(){
   cdAudioCycle("newtech"); 
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

//-----------------------------------------------------------------------------
// Particle

function p2y::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 360.916, 2116.1, 2116.1, 1780.29, 1780.29);
}

function p2b::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 847.741, -1992, -1992, 3422.9, 3422.9);
}

function b2r::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 216.3, 1764.3, 1764.3, 5174.4, 5174.4);
}

function b2p::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 367.11, 304.16, 304.16, 1367.11, 1367.11);
}

function y2r::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 216.3, 1764.3, 1764.3, 5174.4, 5174.4);
}

function y2p::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 367.11, 304.16, 304.16, 1367.11, 1367.11);
}

function r2y::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 360.916, 2116.1, 2116.1, 1780.29, 1780.29);
}

function r2b::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 847.741, -1992, -1992, 3422.9, 3422.9);
}

function LiftToPad(%object, %height, %X1, %X2, %Y1, %Y2)
{
      %xnow = getPosition(%object,x);
	%ynow = getPosition(%object,y);

      %xend = randomInt( %X1, %X2 );
	%yend = randomInt( %Y1, %Y2 );

      %xmid = ( %xnow + %xend ) / 2;
	%ymid = ( %ynow + %yend ) / 2;

 	%a = 0.19 * %height;
	schedule( "raiseZ("@%object@","@%a@","@%xnow@","@%ynow@");", 0.1);

	%b = 0.36 * %height;
	schedule( "raiseZ("@%object@","@%b@","@%xnow@","@%ynow@");", 0.2 );

	%c = 0.51 * %height;
	schedule( "raiseZ("@%object@","@%c@","@%xnow@","@%ynow@");", 0.3 );

	%d = 0.64 * %height;
	schedule( "raiseZ("@%object@","@%d@","@%xnow@","@%ynow@");", 0.4 );

	%e = 0.75 * %height;
	schedule( "raiseZ("@%object@","@%e@","@%xnow@","@%ynow@");", 0.5 );

	%f = 0.84 * %height;
	schedule( "raiseZ("@%object@","@%f@","@%xnow@","@%ynow@");", 0.6 );

	%g = 0.91 * %height;
	schedule( "raiseZ("@%object@","@%g@","@%xnow@","@%ynow@");", 0.7 );

	%h = 0.96 * %height;
	schedule( "raiseZ("@%object@","@%h@","@%xnow@","@%ynow@");", 0.8 );

	%i = 0.99 * %height;
	schedule( "raiseZ("@%object@","@%i@","@%xmid@","@%ymid@");", 0.9 );

	%j = %height;
	schedule( "raiseZ("@%object@","@%j@","@%xend@","@%yend@");", 1.0 );

      %player = playerManager::vehicleIdToPlayerNum(%object);
      say(%player, 0, "teleporter.WAV");
}

function raiseZ(%object, %z, %x, %y)
{
	if(%z < (getTerrainHeight( %x, %y ) + 10) )
  	   %z = getTerrainHeight( %x, %y ) + 10;

	setPosition(%object, %x, %y, %z);
}
